Ruby - Bug #20730

LoadError if Rakefile has shebang
09/13/2024 01:19 AM - watson1978 (Shizuo Fujita)

Status: Closed

Priority: Normal

Assignee:

Target version: 3.4

ruby -v: ruby 3.4.0dev (2024-09-12T720:03:28Z Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:
master 0fc8422a05) +PRISM UNKNOWN
[x86_64-linux]

Description
LoadError exception will be raised when invoke the rake task with latest ruby 3.4-dev.

Reproduce code
Here is example code.
#!/usr/bin/env rake

p "Hello"

Result

$ ruby -v
ruby 3.4.0dev (2024-09-12T20:03:28Z master 0fc8422a05) +PRISM [x86_64-1linux]

$ rake -f test.rake
rake aborted!

LoadError: no Ruby script found in input (LoadError)

(See full trace by running task with --trace)

Associated revisions

Revision 9afc6a981deae6e23d938cf5c2c4baadfeaafdb1 - 09/13/2024 04:51 PM - kddnewton (Kevin Newton)
[PRISM] Only parse shebang on main script

Fixes [Bug #20730]

Revision 9afc6a981deae6e23d938cf5c2c4baadfeaafdb1 - 09/13/2024 04:51 PM - kddnewton (Kevin Newton)
[PRISM] Only parse shebang on main script

Fixes [Bug #20730]

Revision 9afc6a98 - 09/13/2024 04:51 PM - kddnewton (Kevin Newton)

[PRISM] Only parse shebang on main script

Fixes [Bug #20730]

History

#1 - 09/13/2024 03:23 PM - kddnewton (Kevin Newton)

| have opened https:/github.com/ruby/ruby/pull/11617 to fix this.

#2 - 09/13/2024 06:09 PM - kddnewton (Kevin Newton)
- Status changed from Open to Closed

Applied in changeset git|9afc6a981deae6e23d938cf5c2c4baadfeaafdb.
https://github.com/ruby/ruby/pull/11617
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/9afc6a981deae6e23d938cf5c2c4baadfeaafdb1

[PRISM] Only parse shebang on main script

Fixes [Bug #20730]

#3 - 09/14/2024 07:54 AM - nobu (Nobuyoshi Nakada)

ruby command handles a shebang, but it is not a part of the Ruby syntax.
Parsers should not consider shebang lines.
https://bugs.ruby-lang.org/issues/20730
http://www.tcpdf.org

